blob: 8bcaf2f26aecad48cb86cbae29faef73785689a6 [file] [log] [blame]
Peter Stuge09377b72011-08-21 06:24:55 +02001#!/bin/sh
Stefan Reinauer074d9132009-09-26 16:43:17 +00002#
Stefan Reinauer5f1ad892010-05-17 11:02:25 +00003# Copyright (C) 2008-2010 by coresystems GmbH
Stefan Reinauer074d9132009-09-26 16:43:17 +00004# written by Patrick Georgi <patrick.georgi@coresystems.de> and
5# Stefan Reinauer <stefan.reinauer@coresystems.de>
Stefan Reinauer14e22772010-04-27 06:56:47 +00006#
Marc Jones2aac3f62011-08-08 16:07:50 -06007# Copyright (C) 2011 by Sage Electronic Engineering
8#
Stefan Reinauer074d9132009-09-26 16:43:17 +00009# This program is free software; you can redistribute it and/or modify
10# it under the terms of the GNU General Public License as published by
11# the Free Software Foundation; version 2 of the License.
12#
13# This program is distributed in the hope that it will be useful,
14# but WITHOUT ANY WARRANTY; without even the implied warranty of
15# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
16# GNU General Public License for more details.
17#
18# You should have received a copy of the GNU General Public License
19# along with this program; if not, write to the Free Software
Paul Menzela46a7122013-02-23 18:37:27 +010020# Foundation, Inc., 51 Franklin Street, Suite 500, Boston, MA 02110-1335, USA
Stefan Reinauer074d9132009-09-26 16:43:17 +000021#
22
Patrick Georgi8135dba2015-03-17 21:05:20 +010023cd `dirname $0`
24
Patrick Georgi53c388f2015-03-07 09:55:18 +010025CROSSGCC_DATE="March 8th, 2015"
26CROSSGCC_VERSION="1.27"
Stefan Reinauer074d9132009-09-26 16:43:17 +000027
28# default settings
29TARGETDIR=`pwd`/xgcc
30TARGETARCH=i386-elf
31DESTDIR=
32
33# version numbers
Patrick Georgi53c388f2015-03-07 09:55:18 +010034GMP_VERSION=6.0.0
Stefan Reinauer0d2119d2013-07-10 14:27:56 -070035MPFR_VERSION=3.1.2
Paul Menzele6619422015-02-23 10:33:59 +010036MPC_VERSION=1.0.3
Stefan Reinauer5f1ad892010-05-17 11:02:25 +000037LIBELF_VERSION=0.8.13
Patrick Georgi53c388f2015-03-07 09:55:18 +010038GCC_VERSION=4.9.2
Stefan Reinauer0d2119d2013-07-10 14:27:56 -070039GCC_AUTOCONF_VERSION=2.69
Patrick Georgi53c388f2015-03-07 09:55:18 +010040BINUTILS_VERSION=2.25
41GDB_VERSION=7.9
42IASL_VERSION=20150204
43PYTHON_VERSION=3.4.3
Idwer Vollering296a0152012-10-26 01:48:04 +020044EXPAT_VERSION=2.1.0
Stefan Reinauer074d9132009-09-26 16:43:17 +000045
46# archive locations
Patrick Georgi53c388f2015-03-07 09:55:18 +010047GMP_ARCHIVE="http://ftpmirror.gnu.org/gmp/gmp-${GMP_VERSION}a.tar.bz2"
Patrick Georgi6e61ad32012-05-12 23:19:30 +020048MPFR_ARCHIVE="http://ftpmirror.gnu.org/mpfr/mpfr-${MPFR_VERSION}.tar.bz2"
Idwer Vollering7962fc72012-10-25 02:14:09 +020049MPC_ARCHIVE="http://ftpmirror.gnu.org/mpc/mpc-${MPC_VERSION}.tar.gz"
Stefan Reinauer5f1ad892010-05-17 11:02:25 +000050LIBELF_ARCHIVE="http://www.mr511.de/software/libelf-${LIBELF_VERSION}.tar.gz"
Idwer Vollering1cfee0b2012-10-25 02:03:53 +020051GCC_ARCHIVE="http://ftpmirror.gnu.org/gcc/gcc-${GCC_VERSION}/gcc-${GCC_VERSION}.tar.bz2"
Stefan Reinauer0d2119d2013-07-10 14:27:56 -070052BINUTILS_ARCHIVE="http://ftpmirror.gnu.org/binutils/binutils-${BINUTILS_VERSION}.tar.bz2"
Patrick Georgi53c388f2015-03-07 09:55:18 +010053GDB_ARCHIVE="http://ftpmirror.gnu.org/gdb/gdb-${GDB_VERSION}.tar.xz"
54IASL_ARCHIVE="https://acpica.org/sites/acpica/files/acpica-unix-${IASL_VERSION}.tar.gz"
55PYTHON_ARCHIVE="http://www.python.org/ftp/python/${PYTHON_VERSION}/Python-${PYTHON_VERSION}.tar.xz"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +010056EXPAT_ARCHIVE="http://downloads.sourceforge.net/sourceforge/expat/expat-${EXPAT_VERSION}.tar.gz"
Stefan Reinauer074d9132009-09-26 16:43:17 +000057
58GMP_DIR="gmp-${GMP_VERSION}"
59MPFR_DIR="mpfr-${MPFR_VERSION}"
Stefan Reinauer5f1ad892010-05-17 11:02:25 +000060MPC_DIR="mpc-${MPC_VERSION}"
61LIBELF_DIR="libelf-${LIBELF_VERSION}"
Stefan Reinauer074d9132009-09-26 16:43:17 +000062GCC_DIR="gcc-${GCC_VERSION}"
63BINUTILS_DIR="binutils-${BINUTILS_VERSION}"
64GDB_DIR="gdb-${GDB_VERSION}"
Marc Jones2aac3f62011-08-08 16:07:50 -060065IASL_DIR="acpica-unix-${IASL_VERSION}"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +010066PYTHON_DIR="Python-${PYTHON_VERSION}"
67EXPAT_DIR="expat-${EXPAT_VERSION}"
Stefan Reinauer074d9132009-09-26 16:43:17 +000068
Patrick Georgi6321f522015-02-27 23:36:26 +010069unset MAKELEVEL MAKEFLAGS
70
Stefan Reinauer074d9132009-09-26 16:43:17 +000071SAVETEMPS=0
Stefan Reinauer2c3cd122011-11-01 21:43:50 +010072SKIPGDB=1
73SKIPPYTHON=1
Stefan Reinauer074d9132009-09-26 16:43:17 +000074
Patrick Georgi1861ff72011-10-31 12:15:55 +010075red='\033[0;31m'
76RED='\033[1;31m'
77green='\033[0;32m'
78GREEN='\033[1;32m'
79blue='\033[0;34m'
80BLUE='\033[1;34m'
81cyan='\033[0;36m'
82CYAN='\033[1;36m'
83NC='\033[0m' # No Color
Stefan Reinauer074d9132009-09-26 16:43:17 +000084
Stefan Reinauer0d2119d2013-07-10 14:27:56 -070085UNAME=`uname`
86
Patrick Georgi198d23c2012-12-08 08:02:44 +010087normalize_dirs()
88{
89 mkdir -p $DESTDIR$TARGETDIR/lib
90 test -d $DESTDIR$TARGETDIR/lib32 && mv $DESTDIR$TARGETDIR/lib32/* $DESTDIR$TARGETDIR/lib
91 test -d $DESTDIR$TARGETDIR/lib64 && mv $DESTDIR$TARGETDIR/lib64/* $DESTDIR$TARGETDIR/lib
92 rmdir -p $DESTDIR$TARGETDIR/lib32 $DESTDIR$TARGETDIR/lib64
93
94 perl -pi -e "s,/lib32,/lib," $DESTDIR$TARGETDIR/lib/*.la
95 perl -pi -e "s,/lib64,/lib," $DESTDIR$TARGETDIR/lib/*.la
96}
97
Patrick Georgib7062882015-02-24 10:52:14 +010098searchtool()
Stefan Reinauer074d9132009-09-26 16:43:17 +000099{
100 # $1 short name
Patrick Georgib7062882015-02-24 10:52:14 +0100101 # $2 search string
102 # $3 soft fail if set
103 # result: file name of that tool on stdout
104 # or no output if nothing suitable was found
105 search=GNU
106 if [ -n "$2" ]; then
107 search="$2"
108 fi
Stefan Reinauer074d9132009-09-26 16:43:17 +0000109 for i in "$1" "g$1" "gnu$1"; do
110 if test -x "`which $i 2>/dev/null`"; then
Patrick Georgi915c4fc2015-03-09 13:58:23 +0100111 if test `$i --version 2>&1 |grep -c "$search"` \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100112 -gt 0; then
Stefan Reinauer074d9132009-09-26 16:43:17 +0000113 echo $i
114 return
115 fi
116 fi
117 done
Andrew Wub67e9a12014-04-28 18:13:44 +0800118 # A workaround for OSX 10.9 and some BSDs, whose nongnu
119 # patch and tar also work.
120 if [ $UNAME = "Darwin" -o $UNAME = "FreeBSD" -o $UNAME = "NetBSD" ]; then
Patrick Georgib7062882015-02-24 10:52:14 +0100121 if [ "$1" = "patch" -o "$1" = "tar" ]; then
Zheng Bao36156ff2012-09-28 16:18:58 +0800122 if test -x "`which $1 2>/dev/null`"; then
123 echo $1
124 return
125 fi
126 fi
127 fi
Stefan Reinauer074d9132009-09-26 16:43:17 +0000128 printf "${RED}ERROR:${red} Missing toolchain: $1${NC}\n" >&2
Patrick Georgib7062882015-02-24 10:52:14 +0100129 [ -z "$3" ] && exit 1
130 false
Stefan Reinauer074d9132009-09-26 16:43:17 +0000131}
132
Patrick Georgib7062882015-02-24 10:52:14 +0100133TAR=`searchtool tar` || exit $?
134PATCH=`searchtool patch` || exit $?
135MAKE=`searchtool make` || exit $?
Stefan Reinauer074d9132009-09-26 16:43:17 +0000136
Patrick Georgib7062882015-02-24 10:52:14 +0100137searchtool m4 > /dev/null
138searchtool bison > /dev/null
139searchtool flex flex > /dev/null
140searchtool g++ "Free Software Foundation" nofail > /dev/null || \
Patrick Georgi915c4fc2015-03-09 13:58:23 +0100141searchtool clang "clang version" > /dev/null
142searchtool wget > /dev/null
143searchtool bzip2 "bzip2," > /dev/null
Patrick Georgi5fb2b5c2012-05-12 23:25:23 +0200144
Patrick Georgi74c06422015-03-25 18:40:13 +0100145wait_for_build() {
146 # $1: directory in which log file and failure marker are stored
147 cat > "$1/crossgcc-build.log"
148 test -r "$1/.failed" && printf "${RED}failed${NC}. Check $1/crossgcc-build.log.\n" || \
149 printf "${green}ok${NC}\n"
150 test -r "$1/.failed" && exit 1
151 true
152}
153
Stefan Reinauer074d9132009-09-26 16:43:17 +0000154cleanup()
155{
156 printf "Cleaning up temporary files... "
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200157 rm -rf ${BUILDDIRPREFIX}-* combined gcc-* gmp-* mpfr-* mpc-* libelf-* binutils-*
Patrick Georgi969cd932012-12-07 13:13:53 +0100158 rm -rf gdb-* acpica-* python-* expat-*
Stefan Reinauer074d9132009-09-26 16:43:17 +0000159 printf "${green}ok${NC}\n"
160}
161
162myhelp()
163{
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100164 printf "Usage: $0 [-V] [-c] [-p <platform>] [-d <target directory>] [-D <dest dir>] [-G] [-S]\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000165 printf " $0 [-V|--version]\n"
166 printf " $0 [-h|--help]\n\n"
167
168 printf "Options:\n"
169 printf " [-V|--version] print version number and exit\n"
170 printf " [-h|--help] print this help and exit\n"
171 printf " [-c|--clean] remove temporary files before build\n"
172 printf " [-t|--savetemps] don't remove temporary files after build\n"
Patrick Georgic1a75b12011-11-04 21:37:14 +0100173 printf " [-y|--ccache] Use ccache when building cross compiler\n"
Patrick Georgi73166c72010-04-14 20:42:42 +0000174 printf " [-j|--jobs <num>] run <num> jobs in parallel in make\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000175 printf " [-p|--platform <platform>] target platform to build cross compiler for\n"
176 printf " (defaults to $TARGETARCH)\n"
177 printf " [-d|--directory <target dir>] target directory to install cross compiler to\n"
178 printf " (defaults to $TARGETDIR)\n\n"
179 printf " [-D|--destdir <dest dir>] destination directory to install cross compiler to\n"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100180 printf " (for RPM builds, default unset)\n"
181 printf " [-G|--gdb] build GNU debugger\n"
182 printf " [-S|--scripting] build scripting support for GDB\n\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000183}
184
185myversion()
186{
187 # version tag is always printed, so just print the license here
188
189 cat << EOF
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000190Copyright (C) 2008-2010 by coresystems GmbH
Marc Jones2aac3f62011-08-08 16:07:50 -0600191Copyright (C) 2011 by Sage Electronic Engineering
Stefan Reinauer074d9132009-09-26 16:43:17 +0000192
193This program is free software; you can redistribute it and/or modify
194it under the terms of the GNU General Public License as published by
195the Free Software Foundation; version 2 of the License.
196
197This program is distributed in the hope that it will be useful,
198but WITHOUT ANY WARRANTY; without even the implied warranty of
199MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
200GNU General Public License for more details.
201
202EOF
203}
204
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700205printf "${blue}Welcome to the ${red}coreboot${blue} cross toolchain builder v$CROSSGCC_VERSION ($CROSSGCC_DATE)${NC}\n\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000206
Patrick Georgi6bba29f2010-01-29 17:40:52 +0000207# Look if we have getopt. If not, build it.
208export PATH=$PATH:.
209getopt - > /dev/null 2>/dev/null || gcc -o getopt getopt.c
210
Stefan Reinauer074d9132009-09-26 16:43:17 +0000211# parse parameters.. try to find out whether we're running GNU getopt
Peter Stuge09377b72011-08-21 06:24:55 +0200212getoptbrand="`getopt -V | sed -e '1!d' -e 's,^\(......\).*,\1,'`"
213if [ "${getoptbrand}" = "getopt" ]; then
Stefan Reinauer074d9132009-09-26 16:43:17 +0000214 # Detected GNU getopt that supports long options.
Patrick Georgic1a75b12011-11-04 21:37:14 +0100215 args=`getopt -l version,help,clean,directory:,platform:,jobs:,destdir:,savetemps,skip-gdb,ccache Vhcd:p:j:D:tGy -- "$@"`
Stefan Reinauer074d9132009-09-26 16:43:17 +0000216 eval set "$args"
217else
218 # Detected non-GNU getopt
Patrick Georgic1a75b12011-11-04 21:37:14 +0100219 args=`getopt Vhcd:p:j:D:tGy $*`
Stefan Reinauer074d9132009-09-26 16:43:17 +0000220 set -- $args
221fi
222
223if [ $? != 0 ]; then
224 myhelp
225 exit 1
226fi
227
228while true ; do
229 case "$1" in
230 -V|--version) shift; myversion; exit 0;;
231 -h|--help) shift; myhelp; exit 0;;
Patrick Georgi44af57a2013-12-19 22:06:22 +0100232 -c|--clean) shift; clean=1;;
Stefan Reinauer074d9132009-09-26 16:43:17 +0000233 -t|--savetemps) shift; SAVETEMPS=1;;
234 -d|--directory) shift; TARGETDIR="$1"; shift;;
235 -p|--platform) shift; TARGETARCH="$1"; shift;;
236 -D|--destdir) shift; DESTDIR="$1"; shift;;
Patrick Georgi73166c72010-04-14 20:42:42 +0000237 -j|--jobs) shift; JOBS="-j $1"; shift;;
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100238 -G|--gdb) shift; SKIPGDB=0;;
239 -S|--scripting) shift; SKIPPYTHON=0;;
Patrick Georgic1a75b12011-11-04 21:37:14 +0100240 -y|--ccache) shift; USECCACHE=1;;
Patrick Georgid2e0dd52013-06-09 08:05:45 +0200241 --) shift; break;;
Stefan Reinauer074d9132009-09-26 16:43:17 +0000242 -*) printf "Invalid option\n\n"; myhelp; exit 1;;
Patrick Georgid2e0dd52013-06-09 08:05:45 +0200243 *) break;;
Stefan Reinauer074d9132009-09-26 16:43:17 +0000244 esac
245done
246
Ronald G. Minnichb460a662013-05-26 05:33:35 -0700247case "$TARGETARCH" in
Stefan Reinauer24f9cb92015-03-13 22:50:22 +0100248 x86_64-elf) ;;
249 x86_64*) TARGETARCH=x86_64-elf;;
David Hubbard5b0420a2013-05-28 16:33:15 -0600250 i386-elf) ;;
251 i386-mingw32) ;;
Patrick Georgi9b7efa52015-03-08 09:20:36 +0100252 mipsel-elf) ;;
Patrick Georgif0bbc952015-03-07 10:57:25 +0100253 riscv-elf) ;;
Ronald G. Minnichb460a662013-05-26 05:33:35 -0700254 i386*) TARGETARCH=i386-elf;;
Patrick Georgic8883262013-09-19 10:57:58 +0200255 arm*) TARGETARCH=armv7-a-eabi;;
Stefan Reinauer0d2119d2013-07-10 14:27:56 -0700256 aarch64*) TARGETARCH=aarch64-elf;;
257 *) printf "${red}WARNING: Unsupported architecture $TARGETARCH.${NC}\n\n"; ;;
Ronald G. Minnichb460a662013-05-26 05:33:35 -0700258esac
259
260echo "Target arch is now $TARGETARCH"
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200261BUILDDIRPREFIX=build-${TARGETARCH}
262
Patrick Georgi44af57a2013-12-19 22:06:22 +0100263if [ "$clean" = "1" ]; then
264 cleanup
265fi
266
Peter Stugeceacd772011-06-09 04:54:16 +0200267GDB_PACKAGE="GDB"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100268PYTHON_PACKAGE="PYTHON"
269EXPAT_PACKAGE="EXPAT"
Peter Stugeceacd772011-06-09 04:54:16 +0200270if [ $SKIPGDB -eq 1 ]; then
271 printf "Will skip GDB ... ${green}ok${NC}\n"
Peter Stuge0e8ee812011-08-28 11:04:23 +0200272 GDB_ARCHIVE=""
Peter Stugeceacd772011-06-09 04:54:16 +0200273 GDB_PACKAGE=""
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100274 if [ $SKIPPYTHON -eq 0 ]; then
275 printf "Python scripting needs GDB ... disabling ... ${green}ok${NC}\n"
276 SKIPPYTHON=1
277 fi
278fi
279if [ $SKIPPYTHON -eq 1 ]; then
Jonathan A. Kollasch2d7ab4c2011-11-07 13:05:18 -0600280 PYTHON_ARCHIVE=""
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100281 PYTHON_PACKAGE=""
Jonathan A. Kollasch2d7ab4c2011-11-07 13:05:18 -0600282 EXPAT_ARCHIVE=""
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100283 EXPAT_PACKAGE=""
Peter Stugeceacd772011-06-09 04:54:16 +0200284fi
285
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700286# coreboot does not like the GOLD linker
287# USE_GOLD="--enable-gold"
288USE_GOLD=""
289GCC_OPTIONS="--enable-lto"
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000290
Stefan Reinauer074d9132009-09-26 16:43:17 +0000291printf "Downloading tar balls ... \n"
292mkdir -p tarballs
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100293for ARCHIVE in $GMP_ARCHIVE $MPFR_ARCHIVE $MPC_ARCHIVE $LIBELF_ARCHIVE \
Patrick Georgi969cd932012-12-07 13:13:53 +0100294 $GCC_ARCHIVE $BINUTILS_ARCHIVE $GDB_ARCHIVE \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100295 $IASL_ARCHIVE $PYTHON_ARCHIVE $EXPAT_ARCHIVE; do
Stefan Reinauer074d9132009-09-26 16:43:17 +0000296 FILE=`basename $ARCHIVE`
297 printf " * $FILE "
298 test -f tarballs/$FILE && printf "(cached)" || (
299 printf "(downloading)"
300 cd tarballs
Patrick Georgi6e61ad32012-05-12 23:19:30 +0200301 wget --no-check-certificate -q $ARCHIVE
Stefan Reinauer074d9132009-09-26 16:43:17 +0000302 )
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100303 test -f tarballs/$FILE || \
Zheng Bao5b209c02012-09-20 16:09:51 +0800304 printf "\n${RED}Failed to download $FILE.${NC}\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000305 test -f tarballs/$FILE || exit 1
306 printf "\n"
307done
308printf "Downloaded tar balls ... "
309printf "${green}ok${NC}\n"
310
311printf "Unpacking and patching ... \n"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100312for PACKAGE in GMP MPFR MPC LIBELF GCC BINUTILS $PYTHON_PACKAGE \
Patrick Georgi969cd932012-12-07 13:13:53 +0100313 $EXPAT_PACKAGE $GDB_PACKAGE IASL; do
Stefan Reinauer074d9132009-09-26 16:43:17 +0000314 archive=$PACKAGE"_ARCHIVE"
Peter Stuge09377b72011-08-21 06:24:55 +0200315 archive="`eval echo '$'$archive`"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000316 dir=$PACKAGE"_DIR"
Peter Stuge09377b72011-08-21 06:24:55 +0200317 dir="`eval echo '$'${dir}`"
Zheng Baof95bb2d2013-12-13 12:30:46 +0800318 test -d ${dir} && test -f ${dir}/.unpack_success || (
Stefan Reinauer074d9132009-09-26 16:43:17 +0000319 printf " * `basename $archive`\n"
320 FLAGS=zxf
Peter Stuge09377b72011-08-21 06:24:55 +0200321 suffix=`echo $archive | sed 's,.*\.,,'`
322 test "$suffix" = "gz" && FLAGS=zxf
323 test "$suffix" = "bz2" && FLAGS=jxf
Patrick Georgi53c388f2015-03-07 09:55:18 +0100324 test "$suffix" = "xz" && FLAGS="--xz -xf"
Peter Stuge09377b72011-08-21 06:24:55 +0200325 test "$suffix" = "lzma" && FLAGS="--lzma -xf"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000326 $TAR $FLAGS tarballs/`basename $archive`
Peter Stuge09377b72011-08-21 06:24:55 +0200327 for patch in patches/${dir}_*.patch; do
Stefan Reinauer074d9132009-09-26 16:43:17 +0000328 test -r $patch || continue
329 printf " o `basename $patch`\n"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100330 $PATCH -s -N -p0 < `echo $patch` || \
Zheng Bao5b209c02012-09-20 16:09:51 +0800331 printf "\n${RED}Failed $patch.${NC}\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000332 done
Zheng Bao691b313c2013-12-09 14:09:07 +0800333 touch ${dir}/.unpack_success
Stefan Reinauer074d9132009-09-26 16:43:17 +0000334 )
335done
336printf "Unpacked and patched ... "
337printf "${green}ok${NC}\n"
338
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700339CC=cc
Stefan Reinauer0d2119d2013-07-10 14:27:56 -0700340if [ $UNAME = "Darwin" ]; then
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000341 #GCC_OPTIONS="$GCC_OPTIONS --enable-threads=posix"
342
343 # generally the OS X compiler can create x64 binaries.
344 # Per default it generated i386 binaries in 10.5 and x64
345 # binaries in 10.6 (even if the kernel is 32bit)
346 # For some weird reason, 10.5 autodetects an ABI=64 though
347 # so we're setting the ABI explicitly here.
Zheng Bao04ceed62012-10-23 19:41:25 +0800348 if [ `sysctl -n hw.optional.x86_64 2>/dev/null` -eq 1 ] 2>/dev/null; then
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000349 OPTIONS="ABI=64"
350 else
351 OPTIONS="ABI=32"
352 fi
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700353
Stefan Reinauer4266b922012-12-05 16:18:32 -0800354 # In Xcode 4.5.2 the default compiler is clang.
355 # However, this compiler fails to compile gcc 4.7.x. As a
356 # workaround it's possible to compile gcc with llvm-gcc.
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700357 if $CC -v 2>&1 | grep -q LLVM; then
Stefan Reinauer4266b922012-12-05 16:18:32 -0800358 CC=llvm-gcc
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700359 fi
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000360fi
361
Patrick Georgic1a75b12011-11-04 21:37:14 +0100362if [ "$USECCACHE" = 1 ]; then
363 CC="ccache $CC"
364fi
365
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200366mkdir -p ${BUILDDIRPREFIX}-gmp ${BUILDDIRPREFIX}-mpfr ${BUILDDIRPREFIX}-mpc ${BUILDDIRPREFIX}-libelf ${BUILDDIRPREFIX}-binutils \
367 ${BUILDDIRPREFIX}-gcc ${BUILDDIRPREFIX}-python ${BUILDDIRPREFIX}-expat
Stefan Reinauer16bd7892012-12-07 23:57:01 +0100368
369mkdir -p $DESTDIR$TARGETDIR/bin
370export PATH=$DESTDIR$TARGETDIR/bin:$PATH
371
Peter Stugeceacd772011-06-09 04:54:16 +0200372if [ $SKIPGDB -eq 0 ]; then
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200373 mkdir -p ${BUILDDIRPREFIX}-gdb
Peter Stugeceacd772011-06-09 04:54:16 +0200374fi
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200375if [ -f ${BUILDDIRPREFIX}-gmp/.success ]; then
Stefan Reinauer074d9132009-09-26 16:43:17 +0000376 printf "Skipping GMP as it is already built\n"
377else
378printf "Building GMP ${GMP_VERSION} ... "
379(
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200380 cd ${BUILDDIRPREFIX}-gmp
Stefan Reinauer074d9132009-09-26 16:43:17 +0000381 rm -f .failed
Patrick Georgi643c9e82011-11-04 21:30:49 +0100382 CC="$CC" ../${GMP_DIR}/configure --disable-shared --prefix=$TARGETDIR $OPTIONS \
Stefan Reinauer074d9132009-09-26 16:43:17 +0000383 || touch .failed
Patrick Georgi73166c72010-04-14 20:42:42 +0000384 $MAKE $JOBS || touch .failed
Stefan Reinauer074d9132009-09-26 16:43:17 +0000385 $MAKE install DESTDIR=$DESTDIR || touch .failed
Patrick Georgi198d23c2012-12-08 08:02:44 +0100386
387 normalize_dirs
388
Stefan Reinauer074d9132009-09-26 16:43:17 +0000389 if [ ! -f .failed ]; then touch .success; fi
Patrick Georgi74c06422015-03-25 18:40:13 +0100390) 2>&1 | wait_for_build "${BUILDDIRPREFIX}-gmp" || exit 1
Stefan Reinauer074d9132009-09-26 16:43:17 +0000391fi
392
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700393# Now set CFLAGS to match GMP CFLAGS but strip out -pedantic
394# as GCC 4.6.x fails if it's there.
395HOSTCFLAGS=`grep __GMP_CFLAGS $DESTDIR$TARGETDIR/include/gmp.h |cut -d\" -f2 |\
396 sed s,-pedantic,,`
Stefan Reinauer074d9132009-09-26 16:43:17 +0000397
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200398if [ -f ${BUILDDIRPREFIX}-mpfr/.success ]; then
Stefan Reinauer074d9132009-09-26 16:43:17 +0000399 printf "Skipping MPFR as it is already built\n"
400else
401printf "Building MPFR ${MPFR_VERSION} ... "
402(
Stefan Reinauer0d2119d2013-07-10 14:27:56 -0700403 test $UNAME = "Darwin" && CFLAGS="$CFLAGS -force_cpusubtype_ALL"
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200404 cd ${BUILDDIRPREFIX}-mpfr
Stefan Reinauer074d9132009-09-26 16:43:17 +0000405 rm -f .failed
Patrick Georgi643c9e82011-11-04 21:30:49 +0100406 CC="$CC" ../${MPFR_DIR}/configure --disable-shared --prefix=$TARGETDIR \
Stefan Reinauer074d9132009-09-26 16:43:17 +0000407 --infodir=$TARGETDIR/info \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100408 --with-gmp=$DESTDIR$TARGETDIR CFLAGS="$HOSTCFLAGS" || \
409 touch .failed
Patrick Georgi73166c72010-04-14 20:42:42 +0000410 $MAKE $JOBS || touch .failed
Stefan Reinauer074d9132009-09-26 16:43:17 +0000411 $MAKE install DESTDIR=$DESTDIR || touch .failed
412
Patrick Georgi198d23c2012-12-08 08:02:44 +0100413 normalize_dirs
414
Stefan Reinauer074d9132009-09-26 16:43:17 +0000415 # work around build problem of libgmp.la
416 if [ "$DESTDIR" != "" ]; then
417 perl -pi -e "s,$DESTDIR,," $DESTDIR$TARGETDIR/libgmp.la
418 fi
419
420 if [ ! -f .failed ]; then touch .success; fi
Patrick Georgi74c06422015-03-25 18:40:13 +0100421) 2>&1 | wait_for_build "${BUILDDIRPREFIX}-mpfr" || exit 1
Stefan Reinauer074d9132009-09-26 16:43:17 +0000422fi
423
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200424if [ -f ${BUILDDIRPREFIX}-mpc/.success ]; then
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000425 printf "Skipping MPC as it is already built\n"
426else
427printf "Building MPC ${MPC_VERSION} ... "
428(
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200429 cd ${BUILDDIRPREFIX}-mpc
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000430 rm -f .failed
Patrick Georgi643c9e82011-11-04 21:30:49 +0100431 CC="$CC" ../${MPC_DIR}/configure --disable-shared --prefix=$TARGETDIR \
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000432 --infodir=$TARGETDIR/info --with-mpfr=$DESTDIR$TARGETDIR \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100433 --with-gmp=$DESTDIR$TARGETDIR CFLAGS="$HOSTCFLAGS" || \
434 touch .failed
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000435 $MAKE $JOBS || touch .failed
436 $MAKE install DESTDIR=$DESTDIR || touch .failed
437
Patrick Georgi198d23c2012-12-08 08:02:44 +0100438 normalize_dirs
439
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000440 if [ ! -f .failed ]; then touch .success; fi
Patrick Georgi74c06422015-03-25 18:40:13 +0100441) 2>&1 | wait_for_build "${BUILDDIRPREFIX}-mpc" || exit 1
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000442fi
443
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200444if [ -f ${BUILDDIRPREFIX}-libelf/.success ]; then
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000445 printf "Skipping libelf as it is already built\n"
446else
447printf "Building libelf ${LIBELF_VERSION} ... "
448(
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200449 cd ${BUILDDIRPREFIX}-libelf
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000450 rm -f .failed
451 echo "$HOSTCFLAGS"
Patrick Georgi643c9e82011-11-04 21:30:49 +0100452 CC="$CC" CFLAGS="$HOSTCFLAGS" libelf_cv_elf_h_works=no \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100453 ../${LIBELF_DIR}/configure --disable-shared --prefix=$TARGETDIR \
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000454 --infodir=$TARGETDIR/info CFLAGS="$HOSTCFLAGS" || touch .failed
455 $MAKE $JOBS || touch .failed
Scott Duplichan4270a972014-12-12 20:21:40 -0600456 $MAKE install prefix=$DESTDIR$TARGETDIR || touch .failed
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000457
Patrick Georgi198d23c2012-12-08 08:02:44 +0100458 normalize_dirs
459
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000460 if [ ! -f .failed ]; then touch .success; fi
Patrick Georgi74c06422015-03-25 18:40:13 +0100461) 2>&1 | wait_for_build "${BUILDDIRPREFIX}-libelf" || exit 1
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000462fi
463
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200464if [ -f ${BUILDDIRPREFIX}-binutils/.success ]; then
Stefan Reinauer074d9132009-09-26 16:43:17 +0000465 printf "Skipping binutils as it is already built\n"
466else
467printf "Building binutils ${BINUTILS_VERSION} ... "
468(
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700469 # What a pain: binutils don't come with configure
470 # script anymore. Create it:
471 cd binutils-${BINUTILS_VERSION}/
472 autoconf
473 cd ..
474 # Now build binutils
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200475 cd ${BUILDDIRPREFIX}-binutils
Stefan Reinauer074d9132009-09-26 16:43:17 +0000476 rm -f .failed
Patrick Georgi643c9e82011-11-04 21:30:49 +0100477 CC="$CC" ../binutils-${BINUTILS_VERSION}/configure --prefix=$TARGETDIR \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100478 --target=${TARGETARCH} --disable-werror --disable-nls \
479 $USE_GOLD CFLAGS="$HOSTCFLAGS" || touch .failed
Patrick Georgi73166c72010-04-14 20:42:42 +0000480 $MAKE $JOBS || touch .failed
Stefan Reinauer074d9132009-09-26 16:43:17 +0000481 $MAKE install DESTDIR=$DESTDIR || touch .failed
482 if [ ! -f .failed ]; then touch .success; fi
Patrick Georgi74c06422015-03-25 18:40:13 +0100483) 2>&1 | wait_for_build "${BUILDDIRPREFIX}-binutils" || exit 1
Stefan Reinauer074d9132009-09-26 16:43:17 +0000484fi
485
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200486if [ -f ${BUILDDIRPREFIX}-gcc/.success ]; then
Stefan Reinauer074d9132009-09-26 16:43:17 +0000487 printf "Skipping GCC as it is already built\n"
488else
489printf "Building GCC ${GCC_VERSION} ... "
490(
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700491 # Even worse than binutils: GCC does not come with configure
492 # script anymore, but also enforces an obsolete autoconf version
493 # to create it. This is a poster child of how autotools help make
494 # software portable.
495 cd gcc-${GCC_VERSION}
496 sed '/dnl Ensure exactly this Autoconf version is used/d' \
497 config/override.m4 > config/override.m4.new
498 autoconf_version=`autoconf -V | grep "autoconf" | tr ' ' '\n' | tail -1`
499 sed "s/${GCC_AUTOCONF_VERSION}/${autoconf_version}/g" \
500 config/override.m4.new > config/override.m4
501 autoconf
502 cd ..
503 # Now, finally, we can build gcc:
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200504 cd ${BUILDDIRPREFIX}-gcc
Stefan Reinauer074d9132009-09-26 16:43:17 +0000505 rm -f .failed
506 # GCC does not honour HOSTCFLAGS at all. CFLAGS are used for
507 # both target and host object files. This is pretty misdesigned.
508 # There's a work-around called CFLAGS_FOR_BUILD and CFLAGS_FOR_TARGET
509 # but it does not seem to work properly. At least the host library
510 # libiberty is not compiled with CFLAGS_FOR_BUILD.
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700511 CC="$CC" CFLAGS_FOR_TARGET="-O2" CFLAGS="$HOSTCFLAGS" \
512 CFLAGS_FOR_BUILD="$HOSTCFLAGS" ../gcc-${GCC_VERSION}/configure \
Stefan Reinauer074d9132009-09-26 16:43:17 +0000513 --prefix=$TARGETDIR --libexecdir=$TARGETDIR/lib \
Stefan Reinauer6ade1612010-01-16 16:44:20 +0000514 --target=${TARGETARCH} --disable-werror --disable-shared \
Stefan Reinauer074d9132009-09-26 16:43:17 +0000515 --disable-libssp --disable-bootstrap --disable-nls \
Patrick Georgi969cd932012-12-07 13:13:53 +0100516 --disable-libquadmath --without-headers \
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000517 $GCC_OPTIONS --enable-languages="c" $USE_GOLD \
Stefan Reinauer074d9132009-09-26 16:43:17 +0000518 --with-gmp=$DESTDIR$TARGETDIR --with-mpfr=$DESTDIR$TARGETDIR \
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000519 --with-mpc=$DESTDIR$TARGETDIR --with-libelf=$DESTDIR$TARGETDIR \
520 --with-pkgversion="coreboot toolchain v$CROSSGCC_VERSION $CROSSGCC_DATE" \
Stefan Reinauer074d9132009-09-26 16:43:17 +0000521 || touch .failed
Patrick Georgi969cd932012-12-07 13:13:53 +0100522 $MAKE $JOBS CFLAGS_FOR_BUILD="$HOSTCFLAGS" all-gcc || touch .failed
523 $MAKE install-gcc DESTDIR=$DESTDIR || touch .failed
524
525 if [ "`echo $TARGETARCH | grep -c -- -mingw32`" -eq 0 ]; then
526 $MAKE $JOBS CFLAGS_FOR_BUILD="$HOSTCFLAGS" all-target-libgcc || touch .failed
527 $MAKE install-target-libgcc DESTDIR=$DESTDIR || touch .failed
528 fi
529
Stefan Reinauer074d9132009-09-26 16:43:17 +0000530 if [ ! -f .failed ]; then touch .success; fi
Patrick Georgi74c06422015-03-25 18:40:13 +0100531) 2>&1 | wait_for_build "${BUILDDIRPREFIX}-gcc" || exit 1
Stefan Reinauer074d9132009-09-26 16:43:17 +0000532fi
533
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200534if [ -f ${BUILDDIRPREFIX}-expat/.success ]; then
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100535 printf "Skipping Expat as it is already built\n"
Stefan Reinauer1200ec52011-11-01 22:39:41 +0100536elif [ $SKIPPYTHON -eq 1 ]; then
537 printf "Skipping Expat (Python scripting not enabled)\n"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100538else
539printf "Building Expat ${EXPAT_VERSION} ... "
540(
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200541 cd ${BUILDDIRPREFIX}-expat
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100542 rm -f .failed
Patrick Georgi643c9e82011-11-04 21:30:49 +0100543 CC="$CC" CFLAGS="$HOSTCFLAGS" ../${EXPAT_DIR}/configure --disable-shared \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100544 --prefix=$TARGETDIR --target=${TARGETARCH} || touch .failed
545 $MAKE || touch .failed
546 $MAKE install DESTDIR=$DESTDIR || touch .failed
Patrick Georgi198d23c2012-12-08 08:02:44 +0100547
548 normalize_dirs
549
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100550 if [ ! -f .failed ]; then touch .success; fi
Patrick Georgi74c06422015-03-25 18:40:13 +0100551) 2>&1 | wait_for_build "${BUILDDIRPREFIX}-expat" || exit 1
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100552fi
553
554
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200555if [ -f ${BUILDDIRPREFIX}-python/.success ]; then
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100556 printf "Skipping Python as it is already built\n"
Stefan Reinauer1200ec52011-11-01 22:39:41 +0100557elif [ $SKIPPYTHON -eq 1 ]; then
558 printf "Skipping Python (Python scripting not enabled)\n"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100559else
560printf "Building Python ${PYTHON_VERSION} ... "
561(
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200562 cd ${BUILDDIRPREFIX}-python
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100563 rm -f .failed
Patrick Georgi643c9e82011-11-04 21:30:49 +0100564 CC="$CC" CFLAGS="$HOSTCFLAGS" ../${PYTHON_DIR}/configure --prefix=$TARGETDIR \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100565 --target=${TARGETARCH} || touch .failed
566 $MAKE $JOBS || touch .failed
567 $MAKE install DESTDIR=$DESTDIR || touch .failed
Patrick Georgi198d23c2012-12-08 08:02:44 +0100568
569 normalize_dirs
570
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100571 if [ ! -f .failed ]; then touch .success; fi
Patrick Georgi74c06422015-03-25 18:40:13 +0100572) 2>&1 | wait_for_build "${BUILDDIRPREFIX}-python" || exit 1
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100573fi
574
575
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200576if [ -f ${BUILDDIRPREFIX}-gdb/.success ]; then
Stefan Reinauer074d9132009-09-26 16:43:17 +0000577 printf "Skipping GDB as it is already built\n"
Peter Stugeceacd772011-06-09 04:54:16 +0200578elif [ $SKIPGDB -eq 1 ]; then
Stefan Reinauer1200ec52011-11-01 22:39:41 +0100579 printf "Skipping GDB (GDB support not enabled)\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000580else
581printf "Building GDB ${GDB_VERSION} ... "
582(
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200583 cd ${BUILDDIRPREFIX}-gdb
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100584 export PYTHONHOME=$DESTDIR$TARGETDIR
Stefan Reinauer074d9132009-09-26 16:43:17 +0000585 rm -f .failed
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100586 LDFLAGS="-Wl,-rpath,\$\$ORIGIN/../lib/ -L$DESTDIR$TARGETDIR/lib \
587 -lpthread -ldl -lutil" \
Patrick Georgi643c9e82011-11-04 21:30:49 +0100588 CC="$CC" CFLAGS="$HOSTCFLAGS -I$DESTDIR$TARGETDIR/include" \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100589 ../gdb-${GDB_VERSION}/configure --prefix=$TARGETDIR \
590 --target=${TARGETARCH} --disable-werror --disable-nls
Patrick Georgi73166c72010-04-14 20:42:42 +0000591 $MAKE $JOBS || touch .failed
Stefan Reinauer074d9132009-09-26 16:43:17 +0000592 $MAKE install DESTDIR=$DESTDIR || touch .failed
593 if [ ! -f .failed ]; then touch .success; fi
Patrick Georgi74c06422015-03-25 18:40:13 +0100594) 2>&1 | wait_for_build "${BUILDDIRPREFIX}-gdb" || exit 1
Stefan Reinauer074d9132009-09-26 16:43:17 +0000595fi
596
Patrick Georgi6e61ad32012-05-12 23:19:30 +0200597if [ -f $IASL_DIR/source/compiler/.success ]; then
Marc Jones2aac3f62011-08-08 16:07:50 -0600598 printf "Skipping IASL as it is already built\n"
599else
600printf "Building IASL ${IASL_VERSION} ... "
601(
Patrick Georgi74c06422015-03-25 18:40:13 +0100602 RDIR=$IASL_DIR/source/compiler
Idwer Vollering6b11c8b2012-11-15 21:14:36 +0100603 cd $IASL_DIR/generate/unix
Patrick Georgi74c06422015-03-25 18:40:13 +0100604 rm -f $RDIR/.failed
Marc Jones2aac3f62011-08-08 16:07:50 -0600605 CFLAGS="$HOSTCFLAGS"
Stefan Reinauer0d2119d2013-07-10 14:27:56 -0700606 HOST="_LINUX"
607 test $UNAME = "Darwin" && HOST="_APPLE"
608 test $UNAME = "FreeBSD" && HOST="_FreeBSD"
609 test $UNAME = "Cygwin" && HOST="_CYGWIN"
Patrick Georgi74c06422015-03-25 18:40:13 +0100610 HOST="$HOST" OPT_CFLAGS="-O -D_FORTIFY_SOURCE=2" CFLAGS="$CFLAGS" $MAKE CC="$CC" iasl || touch $RDIR/.failed
611 rm -f $DESTDIR$TARGETDIR/bin/iasl || touch $RDIR/.failed
612 cp bin/iasl $DESTDIR$TARGETDIR/bin || touch $RDIR/.failed
613 if [ ! -f $RDIR/.failed ]; then touch $RDIR/.success; fi
614) 2>&1 | wait_for_build "$IASL_DIR/source/compiler" || exit 1
Marc Jones2aac3f62011-08-08 16:07:50 -0600615fi
616
Patrick Georgi5602f2c2015-03-28 15:48:47 +0100617PROGNAME=`basename "$0"`
618rm -f "$DESTDIR$TARGETDIR/$PROGNAME".commit.*
619cp "$PROGNAME" $DESTDIR$TARGETDIR/"$PROGNAME.commit.`git describe`"
Zheng Bao30b895f2013-02-06 18:04:40 +0800620
Stefan Reinauer074d9132009-09-26 16:43:17 +0000621if [ $SAVETEMPS -eq 0 ]; then
622 printf "Cleaning up... "
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200623 rm -rf ${GMP_DIR} ${BUILDDIRPREFIX}-gmp
624 rm -rf ${MPFR_DIR} ${BUILDDIRPREFIX}-mpfr
625 rm -rf ${MPC_DIR} ${BUILDDIRPREFIX}-mpc
626 rm -rf ${LIBELF_DIR} ${BUILDDIRPREFIX}-libelf
627 rm -rf ${BINUTILS_DIR} ${BUILDDIRPREFIX}-binutils
628 rm -rf ${GCC_DIR} ${BUILDDIRPREFIX}-gcc
629 rm -rf ${GDB_DIR} ${BUILDDIRPREFIX}-gdb
630 rm -rf ${EXPAT_DIR} ${BUILDDIRPREFIX}-expat
631 rm -rf ${PYTHON_DIR} ${BUILDDIRPREFIX}-python
Marc Jones2aac3f62011-08-08 16:07:50 -0600632 rm -rf ${IASL_DIR}
Stefan Reinauer074d9132009-09-26 16:43:17 +0000633 printf "${green}ok${NC}\n"
634else
635 printf "Leaving temporary files around... ${green}ok${NC}\n"
636fi
637
638printf "\n${green}You can now run your $TARGETARCH cross toolchain from $TARGETDIR.${NC}\n"
639
640